package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Disables Spring introspection cache for JavaBeans Introspector results used in
 * resolving XML dependencies.
 */
public class CachedIntrospectionResultsCBP extends JavassistClassBytecodeProcessor {

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtConstructor clinit = ctClass.getClassInitializer();
    clinit.insertAfter(
        "classCache = new org.zeroturnaround.javarebel.integration.spring.NopMap();");   
    
    CtMethod getBeanInfoMethod = ctClass.getDeclaredMethod("getBeanInfo");
    getBeanInfoMethod.setBody("{" +
        "   java.beans.Introspector.flushFromCaches(getBeanClass());\n" + 
        "   return java.beans.Introspector.getBeanInfo(getBeanClass());" +
    		"}");
    
    CtMethod getPropertyDescriptorMethod = ctClass.getDeclaredMethod("getPropertyDescriptor");
    getPropertyDescriptorMethod.setBody("{" +
        "   java.beans.Introspector.flushFromCaches(getBeanClass());\n" + 
        "   beanInfo = java.beans.Introspector.getBeanInfo(getBeanClass());" +       
        "   for (int i = 0; i < beanInfo.getPropertyDescriptors().length; i++) {\n" + 
        "      java.beans.PropertyDescriptor pd = beanInfo.getPropertyDescriptors()[i];\n" + 
        "      if (pd.getName().equals($1))\n" + 
        "        return pd;\n" + 
        "    }\n" + 
        "    \n" + 
        "    return null;" +
    		"}");
	}
}
